package com.foreverwin.mesnac.anomaly.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.foreverwin.mesnac.anomaly.dto.AbnormalBillDisposeDto;
import com.foreverwin.mesnac.anomaly.dto.AbnormalBillDto;
import com.foreverwin.mesnac.anomaly.model.AbnormalBill;
import com.foreverwin.mesnac.anomaly.model.AbnormalBillDispose;
import com.foreverwin.modular.core.util.FrontPage;

import java.util.HashMap;
import java.util.List;

/**
 * <p>
 * 异常单 服务类
 * </p>
 *
 * @author robert
 * @since 2021-07-05
 */
public interface AbnormalBillService extends IService<AbnormalBill> {

    /**
     *  分页查询
     * @param frontPage
     * @return
     */
    IPage<AbnormalBill> selectPage(FrontPage<AbnormalBill> frontPage, AbnormalBill abnormalBill);

    List<AbnormalBill> selectList(AbnormalBill abnormalBill);

    String anomalyReportOther(AbnormalBill abnormalBill,
                              AbnormalBillDispose abnormalBillDispose,
                              List<String> dutyCauseType,
                              List<String> dutyType);

    String anomalyReport(AbnormalBill abnormalBill,
                         AbnormalBillDispose abnormalBillDispose,
                         List<String> ncGroupAndNcCodes,
                         List<String> dutyCauseType,
                         List<String> dutyType);

    /**
     * 生成异常单号、创建时间和更新时间
     * @param abnormalBill
     * @param abnormalBillDispose
     */
    void generateAbnormalBill(AbnormalBill abnormalBill, AbnormalBillDispose abnormalBillDispose,List<String> dutyCauseType,List<String> dutyType);

    void cancelBrowse(String handle,String cancelBrowse);

    String anomalyReportDevice(AbnormalBill abnormalBill,AbnormalBillDispose abnormalBillDispose);

    /**
     * 初始化
     */
    HashMap<String,Object> init(String messageType);
    /**
     * 待办事项
     * @param abnormalBillDto
     * @return
     */
    List<AbnormalBillDto> backLog(AbnormalBillDto abnormalBillDto);

    /**
     * 跳转到异常响应**界面所带出的数据
     */
    AbnormalBillDisposeDto findAllByAbnormalNo(AbnormalBill abnormalBill);

    /**
     * 响应处理
     * @param abnormalBill
     */
    void resProcessing(AbnormalBill abnormalBill);

    /**
     * 方案确认
     * @param abnormalBill
     */
    void programConfirm(AbnormalBill abnormalBill,AbnormalBillDispose abnormalBillDispose);

    /**
     * 判责提交
     * @param abnormalBill
     */
    void dutyConfirm(AbnormalBill abnormalBill,AbnormalBillDispose abnormalBillDispose);

    /**
     * 闭环关闭
     * @param abnormalBill
     * @param abnormalBillDispose
     */
    void anomalyShutDown(AbnormalBill abnormalBill,AbnormalBillDispose abnormalBillDispose);

}