package com.foreverwin.mesnac.dispatch.controller;

import com.foreverwin.modular.core.exception.BusinessException;
import com.foreverwin.modular.core.util.R;
import com.foreverwin.modular.core.util.FrontPage;
import com.foreverwin.modular.core.util.CommonMethods;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.foreverwin.mesnac.dispatch.service.CallItemService;
import com.foreverwin.mesnac.dispatch.model.CallItem;
import java.util.List;

/**
 *
 * @author Leon.L
 * @since 2021-06-30
 */
@RestController
@RequestMapping("/Z-CALL-ITEM")
public class CallItemController {

    @Autowired
    public CallItemService callItemService;


    /**
     * 查询所有数据
     *
     * @return
     */
    @ResponseBody
    @PostMapping("/findCallItemList")
    public R findCallItemList(@RequestBody CallItem callItem){
        List<CallItem> result;
        try {
            callItem.setSite(CommonMethods.getSite());
            result = callItemService.findCallItemList(callItem);
        } catch (Exception e) {
            return R.failed(e.getMessage());
        }


        return R.ok(result);
    }


    @ResponseBody
    @PostMapping("/callItem")
    public R callItem(@RequestBody List<CallItem> callItemList) {
        try {
            String site = CommonMethods.getSite();
            String user = CommonMethods.getUser();
            if (callItemList == null || callItemList.size() <= 0) {
                throw BusinessException.build("请至少选择一笔记录");
            }
            callItemService.callItem(site, user, callItemList);
        } catch (Exception e) {
            return R.failed(e.getMessage());
        }

        return R.ok("叫料操作成功");
    }


    @ResponseBody
    @PostMapping("/confirmReceive")
    public R confirmReceive(@RequestBody List<CallItem> callItemList) {
        try {
            String site = CommonMethods.getSite();
            String user = CommonMethods.getUser();
            if (callItemList == null || callItemList.size() <= 0) {
                throw BusinessException.build("请至少选择一笔记录");
            }
            callItemService.confirmReceive(site, user, callItemList);
        } catch (Exception e) {
            return R.failed(e.getMessage());
        }

        return R.ok("确认到料操作成功");
    }
}