package com.foreverwin.mesnac.dispatch.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.foreverwin.mesnac.common.dto.SfcDispatchDto;
import com.foreverwin.mesnac.dispatch.model.CallItem;
import com.baomidou.mybatisplus.extension.service.IService;
import com.foreverwin.modular.core.util.FrontPage;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author Leon.L
 * @since 2021-06-30
 */
public interface CallItemService extends IService<CallItem> {

    /**
     *  分页查询
     * @param frontPage
     * @return
     */
    IPage<CallItem> selectPage(FrontPage<CallItem> frontPage, CallItem callItem);

    List<CallItem> selectList(CallItem callItem);

    /**
     * 保存叫料数据
     *
     * @param site
     * @param user
     * @param sfcDispatchList
     */
    void saveCallItem(String site, String user, List<SfcDispatchDto> sfcDispatchList);

    /**
     * 生产叫料查询
     *
     * @param callItem
     */
    List<CallItem> findCallItemList(CallItem callItem);

    /**
     * 叫料
     *
     * @param site
     * @param user
     * @param callItemList
     */
    void callItem(String site, String user, List<CallItem> callItemList);

    /**
     *  确认到料
     *  ----需要校验叫料明细行中不允许存在叫料类型为材料，且组件物料类型为原材料的行
     *
     * @param site
     * @param user
     * @param callItemList
     */
    void confirmReceive(String site, String user, List<CallItem> callItemList);
}